signature APP =
sig
    structure C : SQL_CLIENT

    val init : unit -> unit
    val done : unit -> unit

    val readTosBody : unit -> string
    val readTosAgree : unit -> string
    val readTosMinorAgree : unit -> string

    type application = { name : string, rname : string, gname : string option, email : string,
			 forward : bool, uses : string, other : string }

    val apply : application -> bool

    val validEmail : string -> bool
    val validUser : string -> bool
    val userExists : string -> bool

    val confirm : int * string -> bool
end